#!/bin/bash
# This script will configure an existing VALT server to function as a primary server. 
# You will need to run VALTStandbyServerConfig.sh on the warm standby server.

standbyip="10.111.3.74"
dbuser="ivsadmin"
dbpass="admin51"
slaveuser="ivs_user"
slavepassword="admin51"

echo "WARNING: DO NOT RUN THIS SCRIPT MULTIPLE TIMES!!!"
echo "You will need to run VALTStandbyServerConfig.sh on the warm standby server."
echo "Press enter to continue."
read r

if [[ $EUID -ne 0 ]]; then
  	echo "You must run this script as root" 2>&1
  	exit 1
else
	apt install rsync
	echo -e "ivsadmin ALL=(ALL) NOPASSWD: /usr/bin/rsync,/usr/bin/systemd-resolve" >> /etc/sudoers

	# ************************************************************************************
	# The IP address may need to be overridden if the IP was not set through the menu 
	# or if the client interface is not used for replication.
        # ************************************************************************************
	# ipaddress="192.168.0.99"

	if [ -s "/usr/local/valt/conf/ipaddress" ];
	then
		ipaddress=$(</usr/local/valt/conf/ipaddress)
	fi
	sed -i "s|bind-address|#bind-address|g" /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "bind-address\t\t= $ipaddress" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "server-id\t\t= 1" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "log_bin\t\t\t= /var/log/mysql/mysql-bin.log" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "binlog_do_db\t\t= v3" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	service mysql restart
	sed -i "s|database_host: localhost|database_host: $ipaddress|g" /var/www/v3/app/config/parameters.yml
	iptables -A INPUT -p tcp -m tcp --dport 3306 -j ACCEPT
	iptables -A OUTPUT -p tcp -m tcp --dport 22 -j ACCEPT
	mysql --defaults-extra-file=/etc/mysql/debian.cnf -e "GRANT ALL PRIVILEGES ON *.* to '$dbuser'@'$standbyip' IDENTIFIED BY '$dbpass';"
	mysql --defaults-extra-file=/etc/mysql/debian.cnf -e "GRANT REPLICATION SLAVE ON *.* TO '$slaveuser'@'$standbyip' IDENTIFIED BY '$slavepassword';"
	mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf -e "FLUSH PRIVILEGES;"
	mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf -e "USE v3;"
	mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf -e "FLUSH TABLES WITH READ LOCK;"
	tmp1=$(mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf v3 -e "SHOW MASTER STATUS\G;" | grep File)
	sqlfile=${tmp1#*:} 
	tmp1=$(mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf v3 -e "SHOW MASTER STATUS\G;" | grep Position)
	position=${tmp1#*:}
	sqlfile=$(echo $sqlfile | xargs)
	mysqldump --defaults-extra-file=/usr/local/valt/conf/sql.cnf --opt v3 > /usr/local/valt/backup/v3_sync.sql
	mysql --defaults-extra-file=/usr/local/valt/conf/sql.cnf -e "UNLOCK TABLES;"
	netfilter-persistent save
	echo -e "Master Log File: $sqlfile"
	echo -e "Master Log Position: $position"
fi
