#!/bin/bash
# This script will configure an existing VALT server to function as a 
# standby server.
# You will need to run VALTPrimaryServerConfig.sh on the primary server.

primaryuser="ivsadmin" 
primarypass="admin51" 
primaryip="10.111.3.73" 
slaveuser="ivs_user"
slavepassword="admin51"
logfile=""
logpos=""

echo "WARNING: DO NOT RUN THIS SCRIPT MULTIPLE TIMES!!!"
echo "MAKE SURE YOU HAVE UPDATED THE LOGFILE, LOGPOS, AND PRIMARYIP VARIABLES IN THIS SCRIPT!!"
echo "MAKE SURE YOU RAN sudo -i PRIOR TO EXECUTING THIS SCRIPT!!"
echo "Press CTRL-C to cancel or press enter to continue."

read r

if [[ $EUID -ne 0 ]]; then
  	echo "You must run this script as root" 2>&1
  	exit 1
else
	apt install rsync
	ssh-keygen -t rsa -f /root/.ssh/id_rsa -q -N ""
	ssh-copy-id -i /root/.ssh/id_rsa.pub ivsadmin@$primaryip
	rsync --rsync-path="sudo rsync" -avz ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/content/valt_recordings /usr/local/WowzaStreamingEngine/content/
	(crontab -l ; echo -e '00 11 * * * rsync --rsync-path="sudo rsync" -avz ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/content/valt_recordings /usr/local/WowzaStreamingEngine/content/') | crontab -
	service apache2 stop
	service WowzaStreamingEngine stop
	service valtcontrols stop
	systemctl disable apache2 
	systemctl disable valtcontrols
	systemctl disable WowzaStreamingEngine
	scp ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/conf/dustin/Application.xml /usr/local/WowzaStreamingEngine/conf/dustin/Application.xml
	
	#*********************************************************************
	# The section below is for HTTPS enabled environments only
	#*********************************************************************
	mkdir /etc/apache2/ssl
	scp ivsadmin@$primaryip:/etc/apache2/ssl/* /etc/apache2/ssl
	scp ivsadmin@$primaryip:/etc/apache2/sites-enabled/v3.conf /etc/apache2/sites-enabled/
	scp ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/conf/valtwowza.jks /usr/local/WowzaStreamingEngine/conf/
	scp ivsadmin@$primaryip:/var/www/v3/nodejs/server.js /var/www/v3/nodejs/
	scp ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/java/lib/security/cacerts /usr/local/WowzaStreamingEngine/java/lib/security/
	scp ivsadmin@$primaryip:/usr/local/WowzaStreamingEngine/conf/VHost.xml /usr/local/WowzaStreamingEngine/conf/
	if ! iptables -S | grep ACCEPT | grep INPUT | grep 443; then
		iptables -A INPUT -p tcp -m tcp --dport 443 -j ACCEPT
	fi
	if ! iptables -S | grep ACCEPT | grep INPUT | grep 444; then
		iptables -A INPUT -p tcp -m tcp --dport 444 -j ACCEPT
	fi
	a2enmod ssl
	
	iptables -A OUTPUT -p tcp -m tcp --dport 22 -j ACCEPT
	iptables -A OUTPUT -p tcp -m tcp --dport 3306 -j ACCEPT
	netfilter-persistent save
	cp /usr/local/valt/conf/sql.cnf /usr/local/valt/conf/standby.cnf
	
	echo -e "[client]" > /usr/local/valt/conf/primary.cnf
	echo -e "host=$primaryip" >> /usr/local/valt/conf/primary.cnf
	echo -e "user=$primaryuser" >> /usr/local/valt/conf/primary.cnf
	echo -e "password=$primarypass" >> /usr/local/valt/conf/primary.cnf
	
	mysqldump --defaults-extra-file=/usr/local/valt/conf/standby.cnf --opt v3 > /usr/local/valt/backup/v3_orig.sql
	mysql --defaults-extra-file=/usr/local/valt/conf/standby.cnf -e "DROP DATABASE v3;"
	mysql --defaults-extra-file=/usr/local/valt/conf/standby.cnf -e "CREATE DATABASE v3;"
	scp ivsadmin@$primaryip:/usr/local/valt/backup/v3_sync.sql /usr/local/valt/backup/v3_sync.sql
	mysql --defaults-extra-file=/usr/local/valt/conf/standby.cnf v3 < /usr/local/valt/backup/v3_sync.sql
	echo -e "server-id\t\t= 2" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "relay-log\t\t= /var/log/mysql/mysql-relay-bin.log" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "log_bin\t\t\t= /var/log/mysql/mysql-bin.log" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	echo -e "binlog_do_db\t\t= v3" >> /etc/mysql/mysql.conf.d/mysqld.cnf
	service mysql restart
	mysql --defaults-extra-file=/usr/local/valt/conf/standby.cnf -e "CHANGE MASTER TO MASTER_HOST='$primaryip',MASTER_USER='$slaveuser', MASTER_PASSWORD='$slavepassword', MASTER_LOG_FILE='$logfile', MASTER_LOG_POS=  $logpos;"
	mysql --defaults-extra-file=/usr/local/valt/conf/standby.cnf -e "START SLAVE;"
	cp failure.sh /usr/local/valt/bin/
	cp restore.sh /usr/local/valt/bin/
	chmod +x /usr/local/valt/bin/failure.sh
	chmod +x /usr/local/valt/bin/restore.sh
fi
